=== debian/changelog ===
guitarix (0.16.0-1) unstable; urgency=low

  * New upstream release (Closes: #630126, #630127)
  * Updated debian/watch
  * debian/control: Build-Depends: libboost-dev instead of libboost1.42-dev
    (Closes: #630438)
  * Fixed debian/copyright to remove template leftovers
  * debian/rules: added build-arch and build-indep targets

 -- Roland Stigge <stigge@antcom.de>  Sun, 19 Jun 2011 17:04:25 +0200

guitarix (0.15.0~svn-r1056-1) unstable; urgency=low

  * New upstream release gx_head (renamed back to guitarix, coordinated with
    upstream) (Closes: #626850)
  * Fixes application crashed on controllers (Closes: #612830)
  * Standards-Version: 3.9.2

 -- Roland Stigge <stigge@antcom.de>  Mon, 16 May 2011 11:46:10 +0200
